#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <signal.h>

#define BUFFER_SIZE 1024
#define PORT 9999
#define BACKLOG 10


int main (int argc, char ** argv)
{
    int head ;
    int sockfd, new_fd;
    struct sockaddr_in my_addr;
    struct sockaddr_in their_addr;
    int sin_size;
    struct sigaction sa;
    int yes = 1;
    int toread;
    int cnt=0;
    int numread;
    char buf[BUFFER_SIZE];
  
    printf("&head     =%p\n",&head);
    printf("&buf      =0x%x\n", &buf);

    if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) == -1) {
	perror ("socket");
	exit (1);
    }

    if (setsockopt (sockfd, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof (int)) == -1) {
	perror ("setsockopt");
	exit (1);
    }

    my_addr.sin_family = AF_INET;	
    my_addr.sin_port = htons (PORT);	
    my_addr.sin_addr.s_addr = INADDR_ANY;
    memset (&(my_addr.sin_zero), '\0', 8);

    if (bind (sockfd, (struct sockaddr *) &my_addr, sizeof (struct sockaddr)) == -1) {
	perror ("bind");
	exit (1);
    }

    if (listen (sockfd, BACKLOG) == -1) {
	perror ("listen");
	exit (1);
    }

    sin_size = sizeof (struct sockaddr_in);
    if ((new_fd = accept (sockfd, (struct sockaddr *) &their_addr,
			&sin_size)) == -1) {
	perror ("accept");
	exit (1);
    }
    printf ("server: got connection from %s\n", inet_ntoa (their_addr.sin_addr));
    close (sockfd);

    while ((numread = recv(new_fd, buf, 5, 0)) == -1) {
	perror ("recv");
	exit (1);
    }
    buf[numread] = 0;
    toread = atoi(buf);
    printf("Reading %d bytes form socket into %d byte buffer\n",toread,BUFFER_SIZE);
    while ((numread = recv(new_fd, buf, toread, 0)) == -1) {
	perror ("recv");
	exit (1);
    }
    buf[numread] = 0;
    return 0;
}


